#include "gcomm.h"
#include "majorbbs.h"
#include "apgcrdc.h"
#include "fsdbbs.h"
#include "gme.h"
//#include "secure.h"
#include "ctrl.h"
#include "dialact.h"
#include "code2.h"
GBOOL LogOnFP(VOID);
GBOOL InputFP(VOID);
GBOOL MyMenu(VOID);

CHAR actcode1[25];
CHAR actcode2[25];

static VOID ctxdun(SHORT save);
static VOID ctxprp(INT msgno,INT amode);
CHAR *userClass(CHAR *UserID);
struct DataTime* getUserTimeSheet(CHAR* userid);
long calculateSessionLimit(CHAR* userid);
VOID showClasses(VOID);
GBOOL isClassAdded(CHAR* cls);
GBOOL isValidClass(CHAR* cls);
INT classvfy(INT fldno,CHAR *answer);
struct usracc * pGetUser(const CHAR *uid);
VOID chargeUser(CHAR *userid);
void doChargeAll(VOID);
INT getSheetNumber(INT i);
VOID chargeOtherUser(VOID);

INT forgtt;
struct DataTime {
                 CHAR CLASS[16];
				 CHAR ACT;
                 CHAR TIMES[24][10];
                 };
#define TimeSheet ((struct DataTime *)FPBB->data)

struct usracc MyACC;
static CHAR ctxfmt[]=                   /* Contact DB answer string format */
     "Activate=%s%c"
     "Class=%s%c"
     "T1=%s%c"
     "T2=%s%c"
     "T3=%s%c"
     "T4=%s%c"
     "T5=%s%c"
     "T6=%s%c"
     "T7=%s%c"
     "T8=%s%c"
     "T9=%s%c"
     "T10=%s%c"
     "T11=%s%c"
     "T12=%s%c"
     "T13=%s%c"
     "T14=%s%c"
     "T15=%s%c"
     "T16=%s%c"
     "T17=%s%c"
     "T18=%s%c"
     "T19=%s%c"
     "T20=%s%c"
     "T21=%s%c"
     "T22=%s%c"
     "T23=%s%c"
     "T24=%s%c";


CHAR ClassCommand[1600];
CHAR tmpctxfsp[1773]=                   /* Contact DB field specifications */
     "Activate(ALT=YES ALT=NO MULTICHOICE)"
     "Class%s"
     "T1 "
     "T2 "
     "T3 "
     "T4 "
     "T5 "
     "T6 "
     "T7 "
     "T8 "
     "T9 "
     "T10 "
     "T11 "
     "T12 "
     "T13 "
     "T14 "
     "T15 "
     "T16 "
     "T17 "
     "T18 "
     "T19 "
     "T20 "
     "T21 "
     "T22 "
     "T23 "
     "T24 "
     "DONE(ALT=SAVE ALT=QUIT ALT=EDIT MULTICHOICE)";

CHAR ctxfsp[]=                   /* Contact DB field specifications */
     "Activate(ALT=YES ALT=NO MULTICHOICE)"
     "Class "
     "T1 "
     "T2 "
     "T3 "
     "T4 "
     "T5 "
     "T6 "
     "T7 "
     "T8 "
     "T9 "
     "T10 "
     "T11 "
     "T12 "
     "T13 "
     "T14 "
     "T15 "
     "T16 "
     "T17 "
     "T18 "
     "T19 "
     "T20 "
     "T21 "
     "T22 "
     "T23 "
     "T24 "
     "DONE(ALT=SAVE ALT=QUIT ALT=EDIT MULTICHOICE)";

long (*old_hdlslim)(unsigned long nas_ip, unsigned short nas_port, struct usracc *puac, char *service);
long (*old_hdlauth)(unsigned long nas_ip, unsigned short nas_port, struct usracc *puac, char *service, unsigned short nas_port_type, char *callerID, void *other);
void (*old_hdllogoff)(unsigned short structsize, void *theuser);
unsigned long(* old_hdlVopAcct)(char *szNasIP, long nPortID, char *szNasID, char *szUid, char *szVopService, char *szSessionID, unsigned long dwSessionTime, unsigned long dwStatusType);

INIT_PROTYPE init2_radius;
SESLIMIT_PROTYPE hdlses2_limit;

HMODULE radiusdll;

static struct usracc acc;
static struct DataTime tmpDataTime;



// Control defines it's own handler for the session limit

long EXPORT newhdl_seslim(unsigned long nas_ip, unsigned short nas_port,
       struct usracc *puac, char *service)
{
    unsigned long retval;

    // We do these four statements so the compiler
    // doesn't warn us against parameters we didn't use!
    (void)nas_ip;
    (void)nas_port;
    (void)puac;
    (void)service;

	if (!mactcode(actcode1,"RadCHarg",13)) return 30;
	retval=calculateSessionLimit(puac->userid);
	shocst("APGRCC: Calculated the session time.","User: %s Time: %lu",puac->userid,retval);

    return retval;
}


void EXPORT init_radiuscrap()
{
  if (!mactcode(actcode1,"RadCHarg",13)) return;
  radiusdll = LoadLibrary("tcpradus.dll");
  init2_radius = NULL;
  hdlses2_limit = NULL;

  if(radiusdll)
  {
    init2_radius = (INIT_PROTYPE)GetProcAddress(radiusdll, "_init__tcpradus");
    hdlses2_limit = (SESLIMIT_PROTYPE)GetProcAddress(radiusdll, "_hdlses_limit");
  }

  // Installs hook for session limit time out
  if(init2_radius && hdlses2_limit)
  {
	init2_radius();
	old_hdlslim = *hdlses2_limit;
	*hdlses2_limit = newhdl_seslim;
	shocst("APG CRDC:","Radius users credit charger installed.");
  }
  else
  {
    shocst("APG CRDC:","ERROR: Unable to start the time control for radius.");
  }

}

void doChargeAll(VOID)
{
	struct RadUsrList *rul;
	USHORT num_users;
	short i;

	// just for some testing purposes:hdlrad_userlist
	num_users = hdlrad_nbusers();
	rul = (struct RadUsrList *) malloc(num_users * sizeof(struct RadUsrList));
	
	if (rul && num_users)
	{
		hdlrad_userlist(num_users, sizeof(struct RadUsrList), rul);
		for (i=0; i<num_users; i++) chargeUser(rul[i].uid);
		free(rul);
	}

	if (mactcode(actcode2,"nOrCHarg",13)) chargeOtherUser();

	rtkick(60, doChargeAll);
}

VOID
chargeOtherUser(VOID)
{
	INT res,i;
	CHAR tmpuid[30];
	i=0;
	if (!mactcode(actcode2,"nOrCHarg",13)) return;
	for (othusn=0 ; othusn < nterms ; othusn++) {
	othusp=usroff(othusn);
	if ((res=incusr(othusn,TRUE,FALSE)) > VACANT) {
		othuap=uacoff(othusn);
		switch (res) {

			case ONLINE:
			break;

			case SUPIPG:
			break;

			default:

			if (othuap->userid[0]=='(')
			{
				if  (othuap->userid[1]=='P')
				{
				strcpy(tmpuid,othuap->userid+5);
				tmpuid[strlen(tmpuid)-1]='\0';
				if (uidxst(tmpuid)) chargeUser(tmpuid);		
				}
			}
			else chargeUser(othuap->userid);

			}
		}
	}
}

INT getSheetNumber(INT i){
	return i;
}

struct module apgcrdc={          /* module interface block               */
     "",                           /*    name used to refer to this module */
     LogOnFP,                      /*    user logon supplemental routine   */
     InputFP,                      /*    input routine if selected         */
     NULL,					       /*    status-input routine if selected  */
     NULL,                         /*    "injoth" routine for this module  */
     NULL,                         /*    user logoff supplemental routine  */
     NULL,                         /*    hangup (lost carrier) routine     */
     NULL,                         /*    midnight cleanup routine          */
     NULL,                         /*    delete-account routine            */
     NULL,                         /*    finish-up (sys shutdown) routine  */
};


HMCVFILE fpmb,qwkmb;
DFAFILE *FPBB,*USERDAT,*FPSND;

VOID EXPORT
init__apgcrdc()           /* the module initialization routine */
{
	stzcpy(apgcrdc.descrp,gmdnam("APGcrdc.MDF"),MNMSIZ);
	forgtt=register_module(&apgcrdc);

	fpmb=opnmsg("APGcrdc.MCV");

	FPBB=dfaOpen("apgcrdc.DAT",sizeof(struct DataTime),NULL);
	USERDAT=dfaOpen("wgsusr2.dat",sizeof(struct usracc),NULL);
	dclvda(fsdroom(ENTPASS,ctxfsp,0)); 

	shocst("APG Credit Charger v1.3","apg_acg@yahoo.com / +98(21)8765231");

	strcpy(actcode1, stgopt(ACTCODE1));
	strcpy(actcode2, stgopt(ACTCODE2));

	if (mactcode(actcode1,"RadCHarg",13) && isfile("Tcpradus.mdf")) init_radiuscrap();
	if (mactcode(actcode2,"nOrCHarg",13)) shocst("APG CRDC:","Normal users and PPP users credit charger installed.");

	rtkick(5, doChargeAll);
	initallfuck("@!2&3%@#!:");
}


GBOOL
InputFP(VOID)
{
    int retcode=1;
	CHAR *ClassDel,WhatCH,*tmpACT;
	if (!mactcode(actcode1,"RadCHarg",13)){
		catastro("Not a valid activation code, contact apg_acg@yahoo.com");
		return 0;
	}
	setmbk(fpmb);
    do {
    bgncnc();
    switch (usrptr->substt) {
        case 0:
            cncchr();
            /* gobble the module select character */
            prfmsg(WELCOME);
			prfmsg(MENU);
				prfmsg(PROMPT);
            usrptr->substt=1;
            break;


	    case 1:
        /* From Menu Selecting... */
		    WhatCH=cncchr();
			if (WhatCH == 'D') {
                //prf("Enter the class you want to DELETE? ");
				prfmsg(ADEL);
                usrptr->substt=3;
               	break;
            }

			if (WhatCH == 'V') {
                //prf("Enter the class you want to VIEW? ");
				prfmsg(AVIEW);
                usrptr->substt=2;
               	break;
            }

			if (WhatCH == 'E') {
            	//prf("Enter the class you want to EDIT? ");
				prfmsg(AEDIT);
            	usrptr->substt=4;
            	break;
            }

			if (WhatCH == 'A') {
			    cncall();
                ctxprp(ENTPASS,1);
				fsdrhd("APG Internet Charger");
				fsdbkg(fsdrft());
                //Function 4 protected field  //fsdscb->flddat[0].flags|=FFFAVD;
				fsdego(classvfy,ctxdun);
				break;
			}

			if (WhatCH == 'X') {
                cncall();
				usrptr->substt=0;
				retcode=0;
				break;
			}

			if (WhatCH == 'L') {
                cncall();
				showClasses();
			}

			if (WhatCH == '?') {
   				prfmsg(WELCOME);
				prfmsg(MENU);
				prfmsg(PROMPT);
    			usrptr->substt=1;
	            break;
			}

       		prfmsg(PROMPT);
 		    usrptr->substt=1;

            break;

		case 2:
        /* Viewing ... */
	        morcnc();
		    ClassDel=strupr(cncwrd());
			dfaSetBlk(FPBB);
			if (dfaAcqEQ(NULL,ClassDel,0)){
                    if (TimeSheet->ACT=='1') tmpACT="YES";
                    else tmpACT="NO";
                    prfmsg(DISP,TimeSheet->CLASS,tmpACT
						,TimeSheet->TIMES[0],TimeSheet->TIMES[1]
						,TimeSheet->TIMES[2],TimeSheet->TIMES[3]
						,TimeSheet->TIMES[4],TimeSheet->TIMES[5]
						,TimeSheet->TIMES[6],TimeSheet->TIMES[7]
						,TimeSheet->TIMES[8],TimeSheet->TIMES[9]
						,TimeSheet->TIMES[10],TimeSheet->TIMES[11]
						,TimeSheet->TIMES[12],TimeSheet->TIMES[13]
						,TimeSheet->TIMES[14],TimeSheet->TIMES[15]
						,TimeSheet->TIMES[16],TimeSheet->TIMES[17]
						,TimeSheet->TIMES[18],TimeSheet->TIMES[19]
						,TimeSheet->TIMES[20],TimeSheet->TIMES[21]
						,TimeSheet->TIMES[22],TimeSheet->TIMES[23]);
					prfmsg(WELCOME);
					prfmsg(MENU);
					prfmsg(PROMPT);
                    dfaRstBlk();
	                usrptr->substt=1;
                    break;
            }
            dfaRstBlk();
            if (ClassDel[0]=='X') {  
				prfmsg(WELCOME);
				prfmsg(MENU);
				prfmsg(PROMPT);
                usrptr->substt=1;
                break;
            }

			if (ClassDel[0]=='?') showClasses();
            //prf("Enter the Class to view?");
			prfmsg(AVIEW);
            usrptr->substt=2;
            break;

		case 3:
			morcnc();
			ClassDel=strupr(cncwrd());
            if (ClassDel[0]=='X') {
				prfmsg(WELCOME);
				prfmsg(MENU);
				prfmsg(PROMPT);
                usrptr->substt=1;
                break;
            }

			if (ClassDel[0]=='?') {
				showClasses();
				prfmsg(ADEL);
				usrptr->substt=3;
				break;
			}

			dfaSetBlk(FPBB);
			if (dfaAcqEQ(NULL,ClassDel,0)) {
                prfmsg(DELED,TimeSheet->CLASS);
				dfaDelete();
				prfmsg(WELCOME);
				prfmsg(MENU);
				prfmsg(PROMPT);
				dfaRstBlk();
				usrptr->substt=1;
				break;
			} 
            dfaRstBlk();


            //prf("Enter the Class to delete?");
			prfmsg(ADEL);
            usrptr->substt=3;
            break;

		case 4:
        /* Editing ... */
			morcnc();
			ClassDel=strupr(cncwrd());
			dfaSetBlk(FPBB);
			if (dfaAcqEQ(NULL,ClassDel,0)) {
                if (TimeSheet->ACT=='1') tmpACT="YES";
                else tmpACT="NO";
                dfaRstBlk();
                cncall();
                fsdroom(ENTPASS,ctxfsp,1);
								sprintf(vdatmp,ctxfmt,tmpACT,'\0',
									TimeSheet->CLASS,'\0',
                                    TimeSheet->TIMES[0],'\0',TimeSheet->TIMES[1],'\0',TimeSheet->TIMES[2],'\0',TimeSheet->TIMES[3],'\0',
                                    TimeSheet->TIMES[4],'\0',TimeSheet->TIMES[5],'\0',TimeSheet->TIMES[6],'\0',TimeSheet->TIMES[7],'\0',
                                    TimeSheet->TIMES[8],'\0',TimeSheet->TIMES[9],'\0',TimeSheet->TIMES[10],'\0',TimeSheet->TIMES[11],'\0',
                                    TimeSheet->TIMES[12],'\0',TimeSheet->TIMES[13],'\0',TimeSheet->TIMES[14],'\0',TimeSheet->TIMES[15],'\0',
                                    TimeSheet->TIMES[16],'\0',TimeSheet->TIMES[17],'\0',TimeSheet->TIMES[18],'\0',TimeSheet->TIMES[19],'\0',
                                    TimeSheet->TIMES[20],'\0',TimeSheet->TIMES[21],'\0',TimeSheet->TIMES[22],'\0',TimeSheet->TIMES[23],'\0');
				fsdapr(vdaptr,vdasiz,vdatmp);
				fsdrhd("APG Internet Charger");
				fsdbkg(fsdrft());
                //Function 4 protected field  //fsdscb->flddat[0].flags|=FFFAVD;
				fsdego(classvfy,ctxdun);
                break;
            }

            dfaRstBlk();
            if (ClassDel[0]=='X') {  
				prfmsg(WELCOME);
				prfmsg(MENU);
				prfmsg(PROMPT);
                usrptr->substt=1;
                break;
            }

			if (ClassDel[0]=='?') showClasses();

            //prf("Enter the Class to edit?");
			prfmsg(AEDIT);
            usrptr->substt=4;
            break;
    }
} while (!endcnc());
outprf(usrnum);
return(retcode);
}

GBOOL
MyMenu(VOID)
{

return 1;
}


static VOID
ctxdun(                                   /* When-done routine               */
SHORT save)                               /* 1=save, 0=quit                  */
{
INT already,i;
CHAR tmpACT[4];

     setmbk(fpmb);
     if (fsdscb->chgcnt == 0) {
          prfmsg(DONNO);                        /* Done, no changes      */
     }
     else if (!save) {
          prfmsg(DONDIS);                         /* Done, discard changes */
     }
     else {
          //already=dfaAcqEQ(NULL,passbuf->userid,0);
          fsdfxt(1,TimeSheet->CLASS,16);
          strupr(TimeSheet->CLASS);
          dfaSetBlk(FPBB);
          already=dfaAcqEQ(NULL,TimeSheet->CLASS,0);
          fsdfxt(0,tmpACT,4);
          if (strcmp(tmpACT,"YES")==0)	TimeSheet->ACT='1';
          else TimeSheet->ACT='0';
          for (i=0;i<=23;i++)
			  	  fsdfxt(i+2,TimeSheet->TIMES[i],10);
          already ? dfaUpdate(NULL) : dfaInsert(NULL);
          // prf("%s %d",TimeSheet->CLASS,already);
          outprf(usrnum);
          prfmsg(DONSAV);                         /* Done, changes saved   */
          }

     dfaRstBlk();
     TimeSheet->ACT=NULL;
     *TimeSheet->CLASS=NULL;
     for (i=0;i<=23;i++) *TimeSheet->TIMES[i]=NULL;

     usrptr->state=0;
     btuinj(usrnum,CRSTG);

}
static VOID
ctxprp(INT msgno,INT amode)
{
	fsdroom(msgno,ctxfsp,amode);
	sprintf(vdatmp,ctxfmt,"YES",'\0',
						"",'\0', "0",'\0', "0",'\0', "0",'\0',
						"0",'\0', "0",'\0', "0",'\0', "0",'\0',
						"0",'\0', "0",'\0', "0",'\0', "0",'\0',
						"0",'\0', "0",'\0', "0",'\0', "0",'\0',
						"0",'\0', "0",'\0', "0",'\0', "0",'\0',
						"0",'\0', "0",'\0', "0",'\0', "0",'\0',"0",'\0');
	fsdapr(vdaptr,vdasiz,vdatmp);

}

INT classvfy(INT fldno,CHAR *answer)
{
  if (fldno == 1 && *answer)
    {
     if (fndcls(answer)==NULL)
       {
		   strcpy(fsdemg,"Class not found!");
		   return(VFYREJ);
       }
	 else if(isClassAdded(answer)) {
         strcpy(fsdemg,"You have added this class before!");
         return(VFYREJ);
	 }
     return(vfyadn(fldno,strupr(answer)));
    }
  else if (fldno>=2 && fldno<2+24) {
	  if (*answer){
	  } else {
		   //strcpy(fsdemg,"You can not empty this");
		   //return(VFYREJ);
		   return(vfyadn(fldno,"0"));
	  }
  }
  return(vfyadn(fldno,answer));
}



GBOOL
LogOnFP(VOID)
{
	return 0;
}

VOID
chargeUser(CHAR *userid)
{
	CHAR line1[80];
	CHAR line2[80];
	int h;
	struct DataTime *tmp=getUserTimeSheet(userid);
	
	if (tmp==NULL) return;
	if (tmp->ACT!='1') return;

	h=dthour(now());

	if (!ntstcrd(userid,atof(tmp->TIMES[h]),1))
	{
		sprintf(line1,"%s Has not Enough Credit (crd# %s)",userid,tmp->TIMES[h]);
		sprintf(line2,"Credit Didn't Charge: %s",userid);
	}
	else
	{
		sprintf(line1,"Credit Charged: %s",tmp->TIMES[h]);
		sprintf(line2,"Hour:%d Credit:%s",h,tmp->TIMES[h]);
		ndedcrd(userid,atof(tmp->TIMES[h]),1,1);
	}

	shocst(line1,line2);
}

struct DataTime*
getUserTimeSheet(CHAR* userid){

	CHAR* cls=userClass(userid);
	if (cls==NULL) return NULL;
	
	memset(&tmpDataTime,0,sizeof(struct DataTime));

	dfaSetBlk(FPBB);
	dfaAcqEQ(&tmpDataTime,cls,0);
	dfaRstBlk();

	return &tmpDataTime;
}

long calculateSessionLimit(CHAR* userid){
	
	struct DataTime *tmp=getUserTimeSheet(userid);
	struct usracc *pUsr=pGetUser(userid);
	long retval=0;
	struct clstab *pCls;
	int i,n,h,m,maxMin;
	long creds,rate;

	n=now();
	h=dthour(n);
	m=dtmin(n);
	pCls=fndcls(pUsr->curcls);

	if (pUsr==NULL) return 0;
	if (pCls==NULL) return 0;
	

	if (tmp==NULL) {
		// return defualt time limit for user
		if(pCls->limday==-1) {
			if (pCls->limcal==-1) retval=24*60;
			else retval=pCls->limcal;
		}
		else {

			if (pCls->limday-pUsr->timtdy/60>0) {
				n=pCls->limday-pUsr->timtdy/60;
				retval=min(n,pCls->limcal);
			}
			else retval=0;
		}
		
	}
	else {
		// calculate time limit from the user credit
		// depends on the class time sheet

		// Goli helps me!
		// 1-dec-2002
		creds=pUsr->creds;
		for (i=h;i<=23;i++){
			if (i==h) maxMin=60-m;
			else maxMin=60;
			rate=atol(tmp->TIMES[i]);

			if (creds-maxMin*rate>0){
				retval+=maxMin;
				creds=creds-maxMin*rate;
			} else {
				retval+=creds/rate;
				break;
			}
		}
	}

	return retval;
}

long howLongCan(long usrCredit,long rate){
	int retval=usrCredit/rate;
}

CHAR
*userClass(CHAR *userid)
{
	struct usracc * tmp=pGetUser(userid);
	return (tmp==NULL)?NULL:tmp->curcls;
}

VOID 
showClasses(VOID){
	struct DataTime tmp;
	setmbk(fpmb);
	prfmsg(SHWCLS0);
	dfaSetBlk(FPBB);
	if (dfaQueryLO(0)){
		do{
			dfaAbsRec(&tmp,0);
			prfmsg(SHWCLS1,tmp.CLASS);
			outprf(usrnum);
		}while(dfaQueryNX());
	}
	
	dfaRstBlk();
	prfmsg(SHWCLS2);
	// outprf(usrnum);
	rstmbk();
}

GBOOL
isClassAdded(CHAR* cls){

	GBOOL k=FALSE;

	if (*cls){
		dfaSetBlk(FPBB);
		k=dfaAcqEQ(NULL,strupr(cls),0);
		dfaRstBlk();
	}
	return k;
}

GBOOL isValidClass(CHAR* cls){
	return (fndcls(cls)==NULL);
}

struct usracc *
pGetUser(const CHAR *uid)
{
	GBOOL got;
	
	memset(&acc,0,sizeof(struct usracc));

    dfaSetBlk(accbb);
    got=dfaAcqEQ(&acc,uid,0);
    dfaRstBlk();
    return(got ? &acc : NULL);
}
